#include "fische.h"

int main(int argc, char* argv[]){

	int old_effect,i,took;
	int fullscreen=0;
	int YRes_seen=0;
	
	XResolution = 500;
	frames_displayed=0;
	screenshot_number=0;
	PI=3.1415;
	sample_buffer=(char *)malloc(2048);
	current_effect=3;
	sample_function=0;
	freeze=0;
	curve_angle=0;
	exit_now=0;
	
	for(i=1;i<argc;i++){
		if (strcmp("-x",argv[i])==0) {XResolution = atoi(argv[i+1]);}
		if (strcmp("-y",argv[i])==0) {YResolution = atoi(argv[i+1]);YRes_seen=1;}
		if (strcmp("-e",argv[i])==0) {current_effect = atoi(argv[i+1]);}
		if (strcmp("-f",argv[i])==0) {fullscreen=1;}
		if (strcmp("-s",argv[i])==0) {sample_function=1;}
		if (strcmp("-h",argv[i])==0) {goto usage;}
	}
	if (current_effect>8){current_effect=3;}
	
	if (YRes_seen==0){YResolution = XResolution/8*3;}
	pixeldata=(char *)malloc(XResolution*(YResolution+10));
	vectorfield=(char *)malloc(XResolution*YResolution*6);
	
	make_vectors();
	setscreen(XResolution,YResolution,fullscreen);
	srand((unsigned int)time((time_t*)NULL));
	while (RQ_Rval+RQ_Gval+RQ_Bval<15){
		RQ_Rval=rand()%10+1;
		RQ_Gval=rand()%10+1;
		RQ_Bval=rand()%10+1;
	}
	makepalette(Rval,Gval,Bval);
	if(sample_function==0){
		alsa_init();
		Sample_Thread=SDL_CreateThread((void *)run_alsa,sample_buffer);
	}
	
	while(!check_input()){
		
		if (SDL_GetTicks()%30000<33){
		if (freeze==0){
		old_effect=current_effect;
			while(current_effect==old_effect){
				old_effect=current_effect;
				current_effect=rand()%8+1;
			}
		make_vectors();
		curve_on=rand()%2;
		}}			
		
		if (SDL_GetTicks()%13000<33){
	  	if (freeze==0){	
	  		if (rand()%5==1){
	  			makepalette_rgb();
	  			goto palette_done1;
	  		}
	  		RQ_Rval=0;
	  		RQ_Bval=0;
	  		while (RQ_Rval+RQ_Gval+RQ_Bval<15){
				RQ_Rval=rand()%10+1;
				RQ_Gval=rand()%10+1;
				RQ_Bval=rand()%10+1;
			}
		}}
		
		if (Rval!=RQ_Rval){
			if (Rval>RQ_Rval){
				Rval--;
				makepalette(Rval,Gval,Bval);
			}
			if (Rval<RQ_Rval){
				Rval++;
				makepalette(Rval,Gval,Bval);
			}
		}
		if (Bval!=RQ_Bval){
			if (Bval>RQ_Bval){
				Bval--;
				makepalette(Rval,Gval,Bval);
			}
			if (Bval<RQ_Bval){
				Bval++;
				makepalette(Rval,Gval,Bval);
			}
		}
		if (Gval!=RQ_Gval){
			if (Gval>RQ_Gval){
				Gval--;
				makepalette(Rval,Gval,Bval);
			}
			if (Gval<RQ_Gval){
				Gval++;
				makepalette(Rval,Gval,Bval);
			}
		}
		palette_done1:
		effect(current_effect);
		frames_displayed++;
	}
	
	exit_now=1;
	if(sample_function==0){
		SDL_WaitThread(Sample_Thread,NULL);
		alsa_close();
	}
	took = SDL_GetTicks() / 1000;
	cleanup();
	printf("\nI displayed %i frames per Second\n",frames_displayed/took);
	goto end;
	usage:
		printf("\nUsage:\n\nfische [options]\n\n-e EffectNumber ...Effect Number to start with\n-x X-Resolution ...Any reasonable, max. 1024\n-f ................Fullscreen\n-s ................read samples from stdin\n-h ................print this help\n\nread README for runtime controls.\n\n");
	end:
	return(1);
}
