#include "fische.h"

// Check for user input
int check_input(){
	
	int exit_now = 0;
	int old_effect;
	char filename[255];
	
	SDL_Event event;
	while(SDL_PollEvent(&event)){
	switch(event.type){
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym){
				case SDLK_a:
					makepalette_rgb();
					break;
				case SDLK_e:
					if (Rval>0){RQ_Rval--;}
					break;
				case SDLK_f:
					if (Gval>0){RQ_Gval--;}
					break;
				case SDLK_v:
					if (Bval>0){RQ_Bval--;}
					break;
				case SDLK_r:
					if (Rval<10){RQ_Rval++;}
					break;
				case SDLK_g:
					if (Gval<10){RQ_Gval++;}
					break;
				case SDLK_b:
					if (Bval<10){RQ_Bval++;}
					break;
				case SDLK_c:
					if (freeze==0){freeze=1;}
					else{freeze=0;}
					break;
				case SDLK_u:
					if (curve_on==0){curve_on=1;}
					else{curve_on=0;}
					break;
				case SDLK_s:
					sprintf(filename,"screenshot%i.bmp",screenshot_number);
					screenshot_number++;
					SDL_SaveBMP(sdl_screen,filename);
					break;					
				case SDLK_ESCAPE:
					exit_now=1;
					break;
				case SDLK_SPACE:
					if (rand()%5==1){
						makepalette_rgb();
						goto palette_done2;
					}
					RQ_Rval=0;
	  				RQ_Bval=0;
	  				while (RQ_Rval+RQ_Gval+RQ_Bval<15){
						RQ_Rval=rand()%10+1;
						RQ_Gval=rand()%10+1;
						RQ_Bval=rand()%10+1;
					}
					palette_done2:
					break;
				case SDLK_RETURN:
					old_effect=current_effect;
					while(current_effect==old_effect){
						old_effect=current_effect;
						current_effect=rand()%8+1;
					}
					make_vectors();
					curve_on=rand()%2;
					break;
				case SDLK_1:
					current_effect=1;
					make_vectors();
					break;
				case SDLK_2:
					current_effect=2;
					make_vectors();
					break;
				case SDLK_3:
					current_effect=3;
					make_vectors();
					break;
				case SDLK_4:
					current_effect=4;
					make_vectors();
					break;
				case SDLK_5:
					current_effect=5;
					make_vectors();
					break;
				case SDLK_6:
					current_effect=6;
					make_vectors();
					break;
				case SDLK_7:
					current_effect=7;
					make_vectors();
					break;
				case SDLK_8:
					current_effect=8;
					make_vectors();
					break;
				default:
					break;
			}
			break;
			
		default:
			break;
	}}
	return exit_now;
	}			
